//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "GraphConfig.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CSPIN"
#pragma resource "*.dfm"

//---------------------------------------------------------------------------
bool EditGraphConfig(TGraphConfig* config)
{
  bool result = false;
  TFGraphConfig* f = new TFGraphConfig(Application);
  try {
    f->cbWantPreview->Checked = config->WantPreview;
    f->cbWantCapture->Checked = config->WantCapture;
    f->cbWantBitmaps->Checked = config->WantBitmaps;
    f->cbWantDVAudio->Checked = config->WantDVAudio;
    f->cbDoPreallocCaptureFile->Checked = config->DoPreallocFile;
    f->cbUseTempFile->Checked = config->UseTempFile;
    f->cbWantAudio->Checked = config->WantAudio;
    f->cbVComp->Checked = true;
    f->cbAComp->Checked = true;
    f->feCaptureFile->Text = config->CaptureFileName;
    f->feTempFile->Text = config->TempCaptureFileName;
    f->cbDVResolution->ItemIndex = int(config->DVResolution);
    f->cbPixelFormat->ItemIndex = int(config->PixelFormat);
    f->sePreallocSize->Value = config->PreallocFileSize;

    for (int i = 0; i<f->cbVSources->Items->Count; i++)
      if (f->cbVSources->Items->Strings[i]==config->VCapSource) {
        f->cbVSources->ItemIndex = i;
        break;
      };
    for (int i = 0; i<f->cbASources->Items->Count; i++)
      if (f->cbASources->Items->Strings[i]==config->ACapSource) {
        f->cbASources->ItemIndex = i;
        break;
      };
    for (int i = 0; i<f->cbVComps->Items->Count; i++) 
      if (f->cbVComps->Items->Strings[i]==config->VComp) {
        f->cbVComps->ItemIndex = i;
        break;
      };
    for (int i = 0; i<f->cbAComps->Items->Count; i++)
      if (f->cbAComps->Items->Strings[i]==config->AComp) {
        f->cbAComps->ItemIndex = i;
        break;
      };

    f->cbVComp->Checked = f->cbVComps->ItemIndex >=0;
    f->cbAComp->Checked = f->cbAComps->ItemIndex >=0;

    result = (f->ShowModal()==mrOk);

    if (result) {
      config->Clear();
      config->WantPreview = f->cbWantPreview->Checked;
      config->WantCapture = f->cbWantCapture->Checked;
      config->WantBitmaps = f->cbWantBitmaps->Checked;
      config->WantDVAudio = f->cbWantDVAudio->Checked;
      config->DoPreallocFile = f->cbDoPreallocCaptureFile->Checked;
      config->UseTempFile = f->cbUseTempFile->Checked;
      config->WantAudio = f->cbWantAudio->Checked;

      config->PreallocFileSize = f->sePreallocSize->Value;
      config->CaptureFileName = f->feCaptureFile->Text;
      config->TempCaptureFileName = f->feTempFile->Text;
      if (f->cbDVResolution->ItemIndex>=0)
        config->DVResolution= TDVResolution(f->cbDVResolution->ItemIndex);
      if (f->cbPixelFormat->ItemIndex>=0)
        config->PixelFormat= TPixelFormat(f->cbPixelFormat->ItemIndex);

      config->VCapSource = f->cbVSources->Text;
      config->ACapSource = f->cbASources->Text;
      if (f->cbVComp->Checked) config->VComp = f->cbVComps->Text;
      if (f->cbAComp->Checked) config->AComp = f->cbAComps->Text;
      config->VCompState = "";
    }
  }
  __finally {
    delete f;
  }
  return result;
}
//---------------------------------------------------------------------------
__fastcall TFGraphConfig::TFGraphConfig(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFGraphConfig::cbWantPreviewClick(TObject *Sender)
{
  cbWantBitmaps->Enabled = cbWantPreview->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TFGraphConfig::cbWantAudioClick(TObject *Sender)
{
  cbASources->Enabled = cbWantAudio->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TFGraphConfig::cbWantCaptureClick(TObject *Sender)
{
  feCaptureFile->Enabled = cbWantCapture->Checked;
  cbDoPreallocCaptureFile->Enabled= cbWantCapture->Checked;
  cbUseTempFile->Enabled = cbWantCapture->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TFGraphConfig::cbUseTempFileClick(TObject *Sender)
{
  feTempFile->Enabled = cbUseTempFile->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TFGraphConfig::cbVCompClick(TObject *Sender)
{
  cbVComps->Enabled = cbVComp->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TFGraphConfig::FormCreate(TObject *Sender)
{
  TStringList* s;

  s = GetVideoDevicesList(true);
  try {
    cbVSources->Items->Assign(s);
  }
  __finally {
    delete s;
  }

  s = GetAudioDevicesList(true);
  try {
    cbASources->Items->Assign(s);
  }
  __finally {
    delete s;
  };

  s = GetVideoCompressorsList(true);
  try {
    cbVComps->Items->Assign(s);
  }
  __finally {
    delete s;
  };

  s = GetAudioCompressorsList(true);
  try {
    cbAComps->Items->Assign(s);
  }
  __finally {
    delete s;
  };
}
//---------------------------------------------------------------------------
void __fastcall TFGraphConfig::cbDoPreallocCaptureFileClick(
      TObject *Sender)
{
  sePreallocSize->Enabled = cbDoPreallocCaptureFile->Checked;
}
//---------------------------------------------------------------------------

